﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
// lisää seuraavat
using System.Configuration;

// tämä esimerkki on apinoitu Microsoftilta osoitteesta http://msdn.microsoft.com/en-us/library/system.configuration.configuration.aspx
// lisää references-listaan System.Configuration 
namespace config
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class configMalli : Window
    {
        public configMalli()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
        }

        private void buttonLuo_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                GKOSection customSection = new GKOSection();

                System.Configuration.Configuration config =
                        ConfigurationManager.OpenExeConfiguration(
                        ConfigurationUserLevel.None);

                if (config.Sections["GKOSection"] == null)
                {
                    config.Sections.Add("GKOSection", customSection);
                }


                // asetustiedostossa on oma osastonsa tietokantayhteyksiä ym. (connectionstrings) varten

                string conStringname = "LocalSqlServer";
                string conString = @"data source=.\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|aspnetdb.mdf;User Instance=true";
                string providerName = "System.Data.SqlClient";

                ConnectionStringSettings connStrSettings = new ConnectionStringSettings();
                connStrSettings.Name = conStringname;
                connStrSettings.ConnectionString = conString;
                connStrSettings.ProviderName = providerName;

                config.ConnectionStrings.ConnectionStrings.Add(connStrSettings);


                // Lisätään uusi asetus
                int appStgCnt =
                    ConfigurationManager.AppSettings.Count;
                string newKey = "NewKey" + appStgCnt.ToString();

                string newValue = DateTime.Now.ToLongDateString() +
                  " " + DateTime.Now.ToLongTimeString();

                config.AppSettings.Settings.Add(newKey, newValue);

                
                config.AppSettings.Settings.Add("Title", "Esimerkki asetusten tallentamisesta");
                // Save the configuration file.
                customSection.SectionInformation.ForceSave = true;
                config.Save(ConfigurationSaveMode.Full);
/*
                // Save the full configuration file and force save even if the file was not modified.
                config.SaveAs("MyConfigFull.config", ConfigurationSaveMode.Full, true);

                // Save only the part of the configuration file that was modified. 
                config.SaveAs("MyConfigModified.config", ConfigurationSaveMode.Modified, true);

                // Save the full configuration file.
                config.SaveAs("MyConfigMinimal.config");
*/



                MessageBox.Show("Created configuration file: " + config.FilePath);

            }
            catch (ConfigurationErrorsException err)
            {
                MessageBox.Show("CreateConfigurationFile: " +  err.ToString());
            }


        }

        private void buttonLue_Click(object sender, RoutedEventArgs e)
        {
            try
            {

                // Get the current configuration file.
                System.Configuration.Configuration config =
                        ConfigurationManager.OpenExeConfiguration(
                        ConfigurationUserLevel.None) as Configuration;

                GKOSection customSection;

                customSection =
                    config.GetSection("GKOSection") as GKOSection;

                textBoxKurssi.Text = customSection.Kurssi;
                textBoxURL.Text =   customSection.Url;
                textBoxOP.Text = customSection.Op.ToString();
//                textBoxUser.Text = Properties.Settings.Default.UserName;


                KeyValueConfigurationCollection settings =
                              config.AppSettings.Settings;


                
                foreach (KeyValueConfigurationElement keyValueElement in settings)
                            {
                               listBox1.Items.Add(keyValueElement.Key + " = " + keyValueElement.Value );
                            }

                        ConnectionStringsSection 
                            conStrSection =
                            config.ConnectionStrings as ConnectionStringsSection;

                            if (conStrSection.ConnectionStrings.Count != 0)
                            {

                                // Get the collection elements.
                                foreach (ConnectionStringSettings connection in
                                  conStrSection.ConnectionStrings)
                                {
                                    string name = connection.Name;
                                    string provider = connection.ProviderName;
                                    string connectionString = connection.ConnectionString;
                                    listBox1.Items.Add(name + " " + provider + " " + connectionString );
                                }
                            }
                        }
                        catch (ConfigurationErrorsException err)
                        {
                            MessageBox.Show(err.Message);
                        }



        }

        private void buttonTallenna_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                System.Configuration.Configuration config =
                        ConfigurationManager.OpenExeConfiguration(
                        ConfigurationUserLevel.None);

                GKOSection customSection =
                     config.GetSection("GKOSection") as GKOSection; 
                
                customSection.Url = textBoxURL.Text;
                customSection.Kurssi = textBoxKurssi.Text;
                customSection.Op = Convert.ToInt16(textBoxOP.Text);

                config.Save(ConfigurationSaveMode.Full);

//                Properties.Settings.Default.UserName = textBoxUser.Text;
//                Properties.Settings.Default.Save();


            }
            catch (ConfigurationErrorsException err)
            {
                MessageBox.Show(err.Message);
            }


        }
    }
    public sealed class GKOSection : ConfigurationSection
    {

        public GKOSection()
        {

        }



        [ConfigurationProperty("Kurssi",
         DefaultValue = "Graafisten käyttöliittymien ohjelmointi",
         IsRequired = true,
         IsKey = true)]
        public string Kurssi
        {
            get
            {
                return (string)this["Kurssi"];
            }
            set
            {
                this["Kurssi"] = value;
            }
        }

        [ConfigurationProperty("url",
            DefaultValue = "http://appro.mit.jyu.fi/gko/",
            IsRequired = true)]
        [RegexStringValidator(@"\w+:\/\/[\w.]+\S*")]
        public string Url
        {
            get
            {
                return (string)this["url"];
            }
            set
            {
                this["url"] = value;
            }
        }

        [ConfigurationProperty("OP",
            DefaultValue = (int)6,
            IsRequired = false)]
        [IntegerValidator(MinValue = 0,
            MaxValue = 20, ExcludeRange = false)]
        public int Op
        {
            get
            {
                return (int)this["OP"];
            }
            set
            {
                this["OP"] = value;
            }
        }



    }


}
